/**
 * Eine Verkehrsampel.
 * 
 * @author 10c 
 * @version 2014-11-28
 */
public class Ampel
{
    // Der Ampelzustand.
    // 'H': "Halt", d. h. rot;
    // 'B': "Bereit", d. h. rot und gelb;
    // 'F': "Fahrt", d. h. grn;
    // 'A': "Achtung", d. h. gelb.
    private char zustand;
    
    // Ein Gehuse und die drei Ampellichter als Referenzattribute.
    private Rechteck gehaeuse;
    private Kreissektor licht1;
    private Kreissektor licht2;
    private Kreissektor licht3;
    
    /**
     * Konstruktor.
     * Erzeuge links oben auf der Leinwand eine Ampel der
     * Breite 50 und der Hhe 140. Schalte sie in den
     * Haltezustand 'H'.
     */
    public Ampel ()
    {
        zustand = 'H';
        
        gehaeuse = new Rechteck ();
        gehaeuse.setzeBreite (50);
        gehaeuse.setzeHoehe (140);
        gehaeuse.setzeFarbe ("grau");
        
        licht1 = new Kreissektor ();
        licht1.setzePosition (5,5);
        licht1.setzeGesamtwinkel (360);
        licht1.setzeRadius (20);
        licht1.setzeFarbe ("rot");
                
        licht2 = new Kreissektor ();
        licht2.setzePosition (5,50);
        licht2.setzeGesamtwinkel (360);
        licht2.setzeRadius (20);
        licht2.setzeFarbe ("schwarz");
                
        licht3 = new Kreissektor ();
        licht3.setzePosition (5,95);
        licht3.setzeGesamtwinkel (360);
        licht3.setzeRadius (20);
        licht3.setzeFarbe ("schwarz");
    }

    /**
     * Schalte die Ampel in ihren nchsten Zustand.
     * Die Zustandsreihenfolge ist "Halt", "Bereit",
     * "Fahrt" und "Achtung" (also rot, rot und gelb,
     * grn, gelb).
     */
    public void schalteUm ()
    {
        switch (zustand)
        {
            case 'H':
            zustand = 'B';
            licht1.setzeFarbe ("rot");
            licht2.setzeFarbe ("gelb");
            licht3.setzeFarbe ("schwarz");
            break;
            
            case 'B':
            zustand = 'F';
            licht1.setzeFarbe ("schwarz");
            licht2.setzeFarbe ("schwarz");
            licht3.setzeFarbe ("gruen");
            break;
          
            case 'F':
            zustand = 'A';
            licht1.setzeFarbe ("schwarz");
            licht2.setzeFarbe ("gelb");
            licht3.setzeFarbe ("schwarz");
            break;
            
            case 'A':
            zustand = 'H';
            licht1.setzeFarbe ("rot");
            licht2.setzeFarbe ("schwarz");
            licht3.setzeFarbe ("schwarz");
            break;
        }
    }
}